package com.oreilly.jent.xml;

/**
 * In general, you may use the code in this book in your programs and 
 * documentation. You do not need to contact us for permission unless 
 * you're reproducing a significant portion of the code. For example, 
 * writing a program that uses several chunks of code from this book does 
 * not require permission. Selling or distributing a CD-ROM of examples 
 * from O'Reilly books does require permission. Answering a question by 
 * citing this book and quoting example code does not require permission. 
 * Incorporating a significant amount of example code from this book into 
 * your product's documentation does require permission.
 * 
 * We appreciate, but do not require, attribution. An attribution usually 
 * includes the title, author, publisher, and ISBN. For example: 
 * 
 *   "Java Enterprise in a Nutshell, Third Edition, 
 *    by Jim Farley and William Crawford 
 *    with Prakash Malani, John G. Norman, and Justin Gehtland. 
 *    Copyright 2006 O'Reilly Media, Inc., 0-596-10142-2."
 *  
 *  If you feel your use of code examples falls outside fair use or the 
 *  permission given above, feel free to contact us at 
 *  permissions@oreilly.com.
 */

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;

public class TreeBuilder {
  
  public static void main(String[] args) {
    DocumentBuilderFactory dbf = DocumentBuilderFactory.newInstance();
    dbf.setValidating(false);
    
    DocumentBuilder db = null;
    try {
      db = dbf.newDocumentBuilder();
    } 
    catch (ParserConfigurationException pce) {
      pce.printStackTrace();
      return;
    }
    
    Document doc = 
      db.getDOMImplementation().createDocument(null, "orders", null);
    // create the initial document element
    Element orderNode = doc.createElement("order");
    orderNode.setAttribute("orderno", "123433");
    
    Node item = doc.createElement("item");
    Node subitem = doc.createElement("number");
    subitem.appendChild(doc.createTextNode("3AGM-5"));
    item.appendChild(subitem);
    
    subitem = doc.createElement("handling");
    subitem.appendChild(doc.createTextNode("With Care"));
    item.appendChild(subitem);
    
    orderNode.appendChild(item);
    doc.getDocumentElement().appendChild(orderNode);
    
    // View the output
    try {
      TransformerFactory tf = TransformerFactory.newInstance();
      Transformer output = tf.newTransformer();
      output.transform(new DOMSource(doc), 
                       new StreamResult(System.out));
    } 
    catch (TransformerException e) {
      e.printStackTrace();
    }
  }
}
